<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/output/fmt.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>fmt.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::util::color::ColorChoice</span>;

<span class="kw">use</span> <span class="ident">std</span>::{
    <span class="ident">fmt</span>::{<span class="self">self</span>, <span class="ident">Display</span>, <span class="ident">Formatter</span>},
    <span class="ident">io</span>::{<span class="self">self</span>, <span class="ident">Write</span>},
};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">enum</span> <span class="ident">Stream</span> {
    <span class="ident">Stdout</span>,
    <span class="ident">Stderr</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">Colorizer</span> {
    <span class="ident">stream</span>: <span class="ident">Stream</span>,
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused</span>)]</span>
    <span class="ident">color_when</span>: <span class="ident">ColorChoice</span>,
    <span class="ident">pieces</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">String</span>, <span class="ident">Style</span>)<span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Colorizer</span> {
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">stream</span>: <span class="ident">Stream</span>, <span class="ident">color_when</span>: <span class="ident">ColorChoice</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Colorizer</span> {
            <span class="ident">stream</span>,
            <span class="ident">color_when</span>,
            <span class="ident">pieces</span>: <span class="macro">vec!</span>[],
        }
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">good</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">msg</span>: <span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">pieces</span>.<span class="ident">push</span>((<span class="ident">msg</span>.<span class="ident">into</span>(), <span class="ident">Style::Good</span>));
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">warning</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">msg</span>: <span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">pieces</span>.<span class="ident">push</span>((<span class="ident">msg</span>.<span class="ident">into</span>(), <span class="ident">Style::Warning</span>));
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">error</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">msg</span>: <span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">pieces</span>.<span class="ident">push</span>((<span class="ident">msg</span>.<span class="ident">into</span>(), <span class="ident">Style::Error</span>));
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">hint</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">msg</span>: <span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">pieces</span>.<span class="ident">push</span>((<span class="ident">msg</span>.<span class="ident">into</span>(), <span class="ident">Style::Hint</span>));
    }

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">never</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">none</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">msg</span>: <span class="kw">impl</span> <span class="ident">Into</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">pieces</span>.<span class="ident">push</span>((<span class="ident">msg</span>.<span class="ident">into</span>(), <span class="ident">Style::Default</span>));
    }
}

<span class="doccomment">/// Printing methods.</span>
<span class="kw">impl</span> <span class="ident">Colorizer</span> {
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;color&quot;</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="kw">use</span> <span class="ident">termcolor</span>::{<span class="ident">BufferWriter</span>, <span class="ident">ColorChoice</span> <span class="kw">as</span> <span class="ident">DepColorChoice</span>, <span class="ident">ColorSpec</span>, <span class="ident">WriteColor</span>};

        <span class="kw">let</span> <span class="ident">color_when</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">color_when</span> {
            <span class="ident">ColorChoice::Always</span> =&gt; <span class="ident">DepColorChoice::Always</span>,
            <span class="ident">ColorChoice::Auto</span> <span class="kw">if</span> <span class="ident">is_a_tty</span>(<span class="self">self</span>.<span class="ident">stream</span>) =&gt; <span class="ident">DepColorChoice::Auto</span>,
            <span class="kw">_</span> =&gt; <span class="ident">DepColorChoice::Never</span>,
        };

        <span class="kw">let</span> <span class="ident">writer</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">stream</span> {
            <span class="ident">Stream::Stderr</span> =&gt; <span class="ident">BufferWriter::stderr</span>(<span class="ident">color_when</span>),
            <span class="ident">Stream::Stdout</span> =&gt; <span class="ident">BufferWriter::stdout</span>(<span class="ident">color_when</span>),
        };

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buffer</span> <span class="op">=</span> <span class="ident">writer</span>.<span class="ident">buffer</span>();

        <span class="kw">for</span> <span class="ident">piece</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">pieces</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">color</span> <span class="op">=</span> <span class="ident">ColorSpec::new</span>();
            <span class="kw">match</span> <span class="ident">piece</span>.<span class="number">1</span> {
                <span class="ident">Style::Good</span> =&gt; {
                    <span class="ident">color</span>.<span class="ident">set_fg</span>(<span class="prelude-val">Some</span>(<span class="ident">termcolor::Color::Green</span>));
                }
                <span class="ident">Style::Warning</span> =&gt; {
                    <span class="ident">color</span>.<span class="ident">set_fg</span>(<span class="prelude-val">Some</span>(<span class="ident">termcolor::Color::Yellow</span>));
                }
                <span class="ident">Style::Error</span> =&gt; {
                    <span class="ident">color</span>.<span class="ident">set_fg</span>(<span class="prelude-val">Some</span>(<span class="ident">termcolor::Color::Red</span>));
                    <span class="ident">color</span>.<span class="ident">set_bold</span>(<span class="bool-val">true</span>);
                }
                <span class="ident">Style::Hint</span> =&gt; {
                    <span class="ident">color</span>.<span class="ident">set_dimmed</span>(<span class="bool-val">true</span>);
                }
                <span class="ident">Style::Default</span> =&gt; {}
            }

            <span class="ident">buffer</span>.<span class="ident">set_color</span>(<span class="kw-2">&amp;</span><span class="ident">color</span>)<span class="question-mark">?</span>;
            <span class="ident">buffer</span>.<span class="ident">write_all</span>(<span class="ident">piece</span>.<span class="number">0</span>.<span class="ident">as_bytes</span>())<span class="question-mark">?</span>;
            <span class="ident">buffer</span>.<span class="ident">reset</span>()<span class="question-mark">?</span>;
        }

        <span class="ident">writer</span>.<span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="ident">buffer</span>)
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;color&quot;</span>))]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">print</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">io::Result</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// [e]println can&#39;t be used here because it panics</span>
        <span class="comment">// if something went wrong. We don&#39;t want that.</span>
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">stream</span> {
            <span class="ident">Stream::Stdout</span> =&gt; {
                <span class="kw">let</span> <span class="ident">stdout</span> <span class="op">=</span> <span class="ident">std::io::stdout</span>();
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">stdout</span> <span class="op">=</span> <span class="ident">stdout</span>.<span class="ident">lock</span>();
                <span class="macro">write!</span>(<span class="ident">stdout</span>, <span class="string">&quot;{}&quot;</span>, <span class="self">self</span>)
            }
            <span class="ident">Stream::Stderr</span> =&gt; {
                <span class="kw">let</span> <span class="ident">stderr</span> <span class="op">=</span> <span class="ident">std::io::stderr</span>();
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">stderr</span> <span class="op">=</span> <span class="ident">stderr</span>.<span class="ident">lock</span>();
                <span class="macro">write!</span>(<span class="ident">stderr</span>, <span class="string">&quot;{}&quot;</span>, <span class="self">self</span>)
            }
        }
    }
}

<span class="doccomment">/// Color-unaware printing. Never uses coloring.</span>
<span class="kw">impl</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">Colorizer</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">for</span> <span class="ident">piece</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">pieces</span> {
            <span class="ident">Display::fmt</span>(<span class="kw-2">&amp;</span><span class="ident">piece</span>.<span class="number">0</span>, <span class="ident">f</span>)<span class="question-mark">?</span>;
        }

        <span class="prelude-val">Ok</span>(())
    }
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Style</span> {
    <span class="ident">Good</span>,
    <span class="ident">Warning</span>,
    <span class="ident">Error</span>,
    <span class="ident">Hint</span>,
    <span class="ident">Default</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Style</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::Default</span>
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;color&quot;</span>)]</span>
<span class="kw">fn</span> <span class="ident">is_a_tty</span>(<span class="ident">stream</span>: <span class="ident">Stream</span>) -&gt; <span class="ident">bool</span> {
    <span class="kw">let</span> <span class="ident">stream</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">stream</span> {
        <span class="ident">Stream::Stdout</span> =&gt; <span class="ident">atty::Stream::Stdout</span>,
        <span class="ident">Stream::Stderr</span> =&gt; <span class="ident">atty::Stream::Stderr</span>,
    };

    <span class="ident">atty::is</span>(<span class="ident">stream</span>)
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>